/* FtrFuser.c
 * Copyright 2001 Matthew J. Holmes
 */
 
#include <PalmOS.h>
#include <FeatureMgr.h>

typedef enum
{
    GetFtrValue   = 32768,
    SetFtrValue,
    ClearFtrValue
}
FeatureCodes;


typedef struct
{
    UInt32 CreatorId;
    UInt16 FeatureId;
    UInt32 FeatureVal;
}
FtrData;


UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
    Err RC;
    FtrData *ptr = (FtrData *)cmdPBP;

    switch(cmd) {
    case GetFtrValue:
        RC = FtrGet(ptr->CreatorId, ptr->FeatureId, &(ptr->FeatureVal));
        break;
    case SetFtrValue:
        RC = FtrSet(ptr->CreatorId, ptr->FeatureId, ptr->FeatureVal);
        break;
    case ClearFtrValue:
        RC = FtrUnregister(ptr->CreatorId, ptr->FeatureId);
        break;
    default:
        return 1; // Hmmm. Called incorrectly, so return failure.
    }

    return RC;
}
