Attribute VB_Name = "VBCrypt"

' VBCrypt.bas
' Copyright 2001 Matthew J. Holmes
'
Option Explicit

Public Const DES_Fuser = "DESFuser"

Public Const InitDES = 32768 + 0
Public Const Encrypt = 32768 + 1
Public Const Decrypt = 32768 + 2

Public Type DESParam
    DbName As String
    DESKey As String
    Index As Integer
    Reserve As Integer
End Type

Public Function Str2Long(ByVal Str As String) As Long

    Dim Total As Long
    
    Total = Asc(Mid(Str, 4, 1))
    Total = Total + (Asc(Mid(Str, 3, 1)) * (2 ^ 8))
    Total = Total + (Asc(Mid(Str, 2, 1)) * (2 ^ 16))
    Total = Total + (Asc(Mid(Str, 1, 1)) * (2 ^ 24))
    
    Str2Long = Total
End Function

Public Sub MakeKey(ByVal Password As String, ByRef Key As String)
    
    Dim i As Integer
    Dim Hi As Single
    Dim Lo As Single

    Hi = 1
    For i = 1 To Len(Password)
        Lo = Lo + Asc(Mid(Password, i, 1)) ^ i
        Hi = Hi * Asc(Mid(Password, i, 1))
    Next i

    While Hi > (2 ^ 31): Hi = Hi / 2: Wend
    While Lo > (2 ^ 31): Lo = Lo / 2: Wend
    
    Key = Right(Hex(Hi), 4) + Left(Hex(Lo), 4)
End Sub

Public Sub StartDES(ByVal MaxRecs As Integer)

    Dim Block As DESParam
    
    Block.Index = MaxRecs
    afPalmOS.CallApp DES_Fuser, InitDES, VarPtr(Block)
End Sub

Public Sub EncryptRec(DbName As String, Index As Integer, Key As String)
    
    Dim Block As DESParam
    
    Block.DbName = DbName
    Block.Index = Index
    Block.DESKey = Key
    afPalmOS.CallApp DES_Fuser, Encrypt, VarPtr(Block)
End Sub

Public Sub DecryptRec(DbName As String, Index As Integer, Key As String)
    
    Dim Block As DESParam
    
    Block.DbName = DbName
    Block.Index = Index
    Block.DESKey = Key
    afPalmOS.CallApp DES_Fuser, Decrypt, VarPtr(Block)
End Sub

