#include "parseevents.h"
#include "debug.h"

TagParseEvents::TagParseEvents(ITagParse* pTagParse)
{

   IEventSource* src;

   m_pTagParse = pTagParse;
   m_pTagParse->AddRef();
   if (SUCCEEDED(m_pTagParse->QueryInterface(IID_IEventSource, (void**)&src)))
   {
	   src->Advise(IID_ITagParseEvent, (ITagParseEvent*)this);
	   src->Release();
   }
}


TagParseEvents::~TagParseEvents()
{
   IEventSource* src;
   if (SUCCEEDED(m_pTagParse->QueryInterface(IID_IEventSource, (void**)&src)))
   {
       src->Unadvise((void *)this);
       src->Release();
   }
   m_pTagParse->Release();
}

STDMETHODIMP TagParseEvents::InvalidTagPair(IString *startTag, IString *endTag)
{
   Debug("Invalid tag pair: ");
   Debug(startTag);
   Debug(", ");
   Debugln(endTag);
   return S_OK;
}

STDMETHODIMP TagParseEvents::TagNotFound(IString *tag)
{
   Debug("Tag not found: ");
   Debugln(tag);
   return S_OK;
}
